/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
#ifndef NoteStore_TYPES_H
#define NoteStore_TYPES_H

#include <Thrift.h>
#include <protocol/TProtocol.h>
#include <transport/TTransport.h>

#include "UserStore_types.h"
#include "Types_types.h"
#include "Errors_types.h"
#include "Limits_types.h"


namespace evernote { namespace edam {

class SyncState {
 public:

  static const char* ascii_fingerprint; // = "2D37F7155AE775C329078C137087C461";
  static const uint8_t binary_fingerprint[16]; // = {0x2D,0x37,0xF7,0x15,0x5A,0xE7,0x75,0xC3,0x29,0x07,0x8C,0x13,0x70,0x87,0xC4,0x61};

  SyncState() : currentTime(0), fullSyncBefore(0), updateCount(0), uploaded(0) {
  }

  virtual ~SyncState() throw() {}

  evernote::edam::Timestamp currentTime;
  evernote::edam::Timestamp fullSyncBefore;
  int32_t updateCount;
  int64_t uploaded;

  struct __isset {
    __isset() : uploaded(false) {}
    bool uploaded;
  } __isset;

  bool operator == (const SyncState & rhs) const
  {
    if (!(currentTime == rhs.currentTime))
      return false;
    if (!(fullSyncBefore == rhs.fullSyncBefore))
      return false;
    if (!(updateCount == rhs.updateCount))
      return false;
    if (__isset.uploaded != rhs.__isset.uploaded)
      return false;
    else if (__isset.uploaded && !(uploaded == rhs.uploaded))
      return false;
    return true;
  }
  bool operator != (const SyncState &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const SyncState & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class SyncChunk {
 public:

  static const char* ascii_fingerprint; // = "A169439675E1057DC2BBB4D64E594D96";
  static const uint8_t binary_fingerprint[16]; // = {0xA1,0x69,0x43,0x96,0x75,0xE1,0x05,0x7D,0xC2,0xBB,0xB4,0xD6,0x4E,0x59,0x4D,0x96};

  SyncChunk() : currentTime(0), chunkHighUSN(0), updateCount(0) {
  }

  virtual ~SyncChunk() throw() {}

  evernote::edam::Timestamp currentTime;
  int32_t chunkHighUSN;
  int32_t updateCount;
  std::vector<evernote::edam::Note>  notes;
  std::vector<evernote::edam::Notebook>  notebooks;
  std::vector<evernote::edam::Tag>  tags;
  std::vector<evernote::edam::SavedSearch>  searches;
  std::vector<evernote::edam::Resource>  resources;
  std::vector<evernote::edam::Guid>  expungedNotes;
  std::vector<evernote::edam::Guid>  expungedNotebooks;
  std::vector<evernote::edam::Guid>  expungedTags;
  std::vector<evernote::edam::Guid>  expungedSearches;

  struct __isset {
    __isset() : chunkHighUSN(false), notes(false), notebooks(false), tags(false), searches(false), resources(false), expungedNotes(false), expungedNotebooks(false), expungedTags(false), expungedSearches(false) {}
    bool chunkHighUSN;
    bool notes;
    bool notebooks;
    bool tags;
    bool searches;
    bool resources;
    bool expungedNotes;
    bool expungedNotebooks;
    bool expungedTags;
    bool expungedSearches;
  } __isset;

  bool operator == (const SyncChunk & rhs) const
  {
    if (!(currentTime == rhs.currentTime))
      return false;
    if (__isset.chunkHighUSN != rhs.__isset.chunkHighUSN)
      return false;
    else if (__isset.chunkHighUSN && !(chunkHighUSN == rhs.chunkHighUSN))
      return false;
    if (!(updateCount == rhs.updateCount))
      return false;
    if (__isset.notes != rhs.__isset.notes)
      return false;
    else if (__isset.notes && !(notes == rhs.notes))
      return false;
    if (__isset.notebooks != rhs.__isset.notebooks)
      return false;
    else if (__isset.notebooks && !(notebooks == rhs.notebooks))
      return false;
    if (__isset.tags != rhs.__isset.tags)
      return false;
    else if (__isset.tags && !(tags == rhs.tags))
      return false;
    if (__isset.searches != rhs.__isset.searches)
      return false;
    else if (__isset.searches && !(searches == rhs.searches))
      return false;
    if (__isset.resources != rhs.__isset.resources)
      return false;
    else if (__isset.resources && !(resources == rhs.resources))
      return false;
    if (__isset.expungedNotes != rhs.__isset.expungedNotes)
      return false;
    else if (__isset.expungedNotes && !(expungedNotes == rhs.expungedNotes))
      return false;
    if (__isset.expungedNotebooks != rhs.__isset.expungedNotebooks)
      return false;
    else if (__isset.expungedNotebooks && !(expungedNotebooks == rhs.expungedNotebooks))
      return false;
    if (__isset.expungedTags != rhs.__isset.expungedTags)
      return false;
    else if (__isset.expungedTags && !(expungedTags == rhs.expungedTags))
      return false;
    if (__isset.expungedSearches != rhs.__isset.expungedSearches)
      return false;
    else if (__isset.expungedSearches && !(expungedSearches == rhs.expungedSearches))
      return false;
    return true;
  }
  bool operator != (const SyncChunk &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const SyncChunk & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class NoteFilter {
 public:

  static const char* ascii_fingerprint; // = "E3FEA280E924E0A51D5D872FA8A51D7F";
  static const uint8_t binary_fingerprint[16]; // = {0xE3,0xFE,0xA2,0x80,0xE9,0x24,0xE0,0xA5,0x1D,0x5D,0x87,0x2F,0xA8,0xA5,0x1D,0x7F};

  NoteFilter() : order(0), ascending(0), words(""), notebookGuid(""), timeZone(""), inactive(0) {
  }

  virtual ~NoteFilter() throw() {}

  int32_t order;
  bool ascending;
  std::string words;
  evernote::edam::Guid notebookGuid;
  std::vector<evernote::edam::Guid>  tagGuids;
  std::string timeZone;
  bool inactive;

  struct __isset {
    __isset() : order(false), ascending(false), words(false), notebookGuid(false), tagGuids(false), timeZone(false), inactive(false) {}
    bool order;
    bool ascending;
    bool words;
    bool notebookGuid;
    bool tagGuids;
    bool timeZone;
    bool inactive;
  } __isset;

  bool operator == (const NoteFilter & rhs) const
  {
    if (__isset.order != rhs.__isset.order)
      return false;
    else if (__isset.order && !(order == rhs.order))
      return false;
    if (__isset.ascending != rhs.__isset.ascending)
      return false;
    else if (__isset.ascending && !(ascending == rhs.ascending))
      return false;
    if (__isset.words != rhs.__isset.words)
      return false;
    else if (__isset.words && !(words == rhs.words))
      return false;
    if (__isset.notebookGuid != rhs.__isset.notebookGuid)
      return false;
    else if (__isset.notebookGuid && !(notebookGuid == rhs.notebookGuid))
      return false;
    if (__isset.tagGuids != rhs.__isset.tagGuids)
      return false;
    else if (__isset.tagGuids && !(tagGuids == rhs.tagGuids))
      return false;
    if (__isset.timeZone != rhs.__isset.timeZone)
      return false;
    else if (__isset.timeZone && !(timeZone == rhs.timeZone))
      return false;
    if (__isset.inactive != rhs.__isset.inactive)
      return false;
    else if (__isset.inactive && !(inactive == rhs.inactive))
      return false;
    return true;
  }
  bool operator != (const NoteFilter &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const NoteFilter & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class NoteList {
 public:

  static const char* ascii_fingerprint; // = "DEB3817E0450DCCACC3B6F71600E8172";
  static const uint8_t binary_fingerprint[16]; // = {0xDE,0xB3,0x81,0x7E,0x04,0x50,0xDC,0xCA,0xCC,0x3B,0x6F,0x71,0x60,0x0E,0x81,0x72};

  NoteList() : startIndex(0), totalNotes(0) {
  }

  virtual ~NoteList() throw() {}

  int32_t startIndex;
  int32_t totalNotes;
  std::vector<evernote::edam::Note>  notes;
  std::vector<std::string>  stoppedWords;
  std::vector<std::string>  searchedWords;

  struct __isset {
    __isset() : stoppedWords(false), searchedWords(false) {}
    bool stoppedWords;
    bool searchedWords;
  } __isset;

  bool operator == (const NoteList & rhs) const
  {
    if (!(startIndex == rhs.startIndex))
      return false;
    if (!(totalNotes == rhs.totalNotes))
      return false;
    if (!(notes == rhs.notes))
      return false;
    if (__isset.stoppedWords != rhs.__isset.stoppedWords)
      return false;
    else if (__isset.stoppedWords && !(stoppedWords == rhs.stoppedWords))
      return false;
    if (__isset.searchedWords != rhs.__isset.searchedWords)
      return false;
    else if (__isset.searchedWords && !(searchedWords == rhs.searchedWords))
      return false;
    return true;
  }
  bool operator != (const NoteList &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const NoteList & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class NoteCollectionCounts {
 public:

  static const char* ascii_fingerprint; // = "4A4A773E0979C92FFBF7D8D9EE2AB6F9";
  static const uint8_t binary_fingerprint[16]; // = {0x4A,0x4A,0x77,0x3E,0x09,0x79,0xC9,0x2F,0xFB,0xF7,0xD8,0xD9,0xEE,0x2A,0xB6,0xF9};

  NoteCollectionCounts() : trashCount(0) {
  }

  virtual ~NoteCollectionCounts() throw() {}

  std::map<evernote::edam::Guid, int32_t>  notebookCounts;
  std::map<evernote::edam::Guid, int32_t>  tagCounts;
  int32_t trashCount;

  struct __isset {
    __isset() : notebookCounts(false), tagCounts(false), trashCount(false) {}
    bool notebookCounts;
    bool tagCounts;
    bool trashCount;
  } __isset;

  bool operator == (const NoteCollectionCounts & rhs) const
  {
    if (__isset.notebookCounts != rhs.__isset.notebookCounts)
      return false;
    else if (__isset.notebookCounts && !(notebookCounts == rhs.notebookCounts))
      return false;
    if (__isset.tagCounts != rhs.__isset.tagCounts)
      return false;
    else if (__isset.tagCounts && !(tagCounts == rhs.tagCounts))
      return false;
    if (__isset.trashCount != rhs.__isset.trashCount)
      return false;
    else if (__isset.trashCount && !(trashCount == rhs.trashCount))
      return false;
    return true;
  }
  bool operator != (const NoteCollectionCounts &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const NoteCollectionCounts & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class AdImpressions {
 public:

  static const char* ascii_fingerprint; // = "6435B39C87AB0E30F30BEDEFD7328C0D";
  static const uint8_t binary_fingerprint[16]; // = {0x64,0x35,0xB3,0x9C,0x87,0xAB,0x0E,0x30,0xF3,0x0B,0xED,0xEF,0xD7,0x32,0x8C,0x0D};

  AdImpressions() : adId(0), impressionCount(0), impressionTime(0) {
  }

  virtual ~AdImpressions() throw() {}

  int32_t adId;
  int32_t impressionCount;
  int32_t impressionTime;

  bool operator == (const AdImpressions & rhs) const
  {
    if (!(adId == rhs.adId))
      return false;
    if (!(impressionCount == rhs.impressionCount))
      return false;
    if (!(impressionTime == rhs.impressionTime))
      return false;
    return true;
  }
  bool operator != (const AdImpressions &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const AdImpressions & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class AdParameters {
 public:

  static const char* ascii_fingerprint; // = "79324A5AA9462D413B19AED97F540DB7";
  static const uint8_t binary_fingerprint[16]; // = {0x79,0x32,0x4A,0x5A,0xA9,0x46,0x2D,0x41,0x3B,0x19,0xAE,0xD9,0x7F,0x54,0x0D,0xB7};

  AdParameters() : clientLanguage(""), supportHtml(0) {
  }

  virtual ~AdParameters() throw() {}

  std::string clientLanguage;
  std::vector<AdImpressions>  impressions;
  bool supportHtml;

  struct __isset {
    __isset() : clientLanguage(false), impressions(false), supportHtml(false) {}
    bool clientLanguage;
    bool impressions;
    bool supportHtml;
  } __isset;

  bool operator == (const AdParameters & rhs) const
  {
    if (__isset.clientLanguage != rhs.__isset.clientLanguage)
      return false;
    else if (__isset.clientLanguage && !(clientLanguage == rhs.clientLanguage))
      return false;
    if (__isset.impressions != rhs.__isset.impressions)
      return false;
    else if (__isset.impressions && !(impressions == rhs.impressions))
      return false;
    if (__isset.supportHtml != rhs.__isset.supportHtml)
      return false;
    else if (__isset.supportHtml && !(supportHtml == rhs.supportHtml))
      return false;
    return true;
  }
  bool operator != (const AdParameters &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const AdParameters & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

class NoteEmailParameters {
 public:

  static const char* ascii_fingerprint; // = "C3ACA35A0D83E8AB060F23AFC26AD164";
  static const uint8_t binary_fingerprint[16]; // = {0xC3,0xAC,0xA3,0x5A,0x0D,0x83,0xE8,0xAB,0x06,0x0F,0x23,0xAF,0xC2,0x6A,0xD1,0x64};

  NoteEmailParameters() : guid(""), subject(""), message("") {
  }

  virtual ~NoteEmailParameters() throw() {}

  std::string guid;
  evernote::edam::Note note;
  std::vector<std::string>  toAddresses;
  std::vector<std::string>  ccAddresses;
  std::string subject;
  std::string message;

  struct __isset {
    __isset() : guid(false), note(false), toAddresses(false), ccAddresses(false), subject(false), message(false) {}
    bool guid;
    bool note;
    bool toAddresses;
    bool ccAddresses;
    bool subject;
    bool message;
  } __isset;

  bool operator == (const NoteEmailParameters & rhs) const
  {
    if (__isset.guid != rhs.__isset.guid)
      return false;
    else if (__isset.guid && !(guid == rhs.guid))
      return false;
    if (__isset.note != rhs.__isset.note)
      return false;
    else if (__isset.note && !(note == rhs.note))
      return false;
    if (__isset.toAddresses != rhs.__isset.toAddresses)
      return false;
    else if (__isset.toAddresses && !(toAddresses == rhs.toAddresses))
      return false;
    if (__isset.ccAddresses != rhs.__isset.ccAddresses)
      return false;
    else if (__isset.ccAddresses && !(ccAddresses == rhs.ccAddresses))
      return false;
    if (__isset.subject != rhs.__isset.subject)
      return false;
    else if (__isset.subject && !(subject == rhs.subject))
      return false;
    if (__isset.message != rhs.__isset.message)
      return false;
    else if (__isset.message && !(message == rhs.message))
      return false;
    return true;
  }
  bool operator != (const NoteEmailParameters &rhs) const {
    return !(*this == rhs);
  }

  bool operator < (const NoteEmailParameters & ) const;

  uint32_t read(apache::thrift::protocol::TProtocol* iprot);
  uint32_t write(apache::thrift::protocol::TProtocol* oprot) const;

};

}} // namespace

#endif
